import javax.microedition.midlet.* ;
import javax.microedition.lcdui.* ;


class CalCanvas extends Canvas implements CommandListener {

	private int     width = getWidth () ;
	private int     height= getHeight();
	private int widthoffset = (width-110) / 2 + 4 ;
	private int  updatenum = -1 ;
	private int      operand = 0 ;
	private int  keta = 0 ;
	private int  nextDspClear = 1 ;
	private char DispOp = ' ';

	private boolean  isdot = false ;
	private boolean  cls_state = false ;

	private String DispOld = "";
	private String Clip ="0";
	private String DispProp ="0" ;
	private int[] calx = new int[17] ;
	private int[] caly = new int[17] ;
	private String[]  cals = new String[17] ;
	private myMath origin = new myMath();
	private myMath tmp = new myMath();


	public CalCanvas() {
		int heightoffset= ((getHeight()-128) / 2) + 26 ;
		calx[ 0] = 53+widthoffset ; caly[ 0] = 90+heightoffset ;
		calx[ 1] = 13+widthoffset ; caly[ 1] = 45+heightoffset ;
		calx[ 2] = 53+widthoffset ; caly[ 2] = 45+heightoffset ;
		calx[ 3] = 89+widthoffset ; caly[ 3] = 45+heightoffset ;
		calx[ 4] = 13+widthoffset ; caly[ 4] = 60+heightoffset ;
		calx[ 5] = 53+widthoffset ; caly[ 5] = 60+heightoffset ;
		calx[ 6] = 89+widthoffset ; caly[ 6] = 60+heightoffset ;
		calx[ 7] = 13+widthoffset ; caly[ 7] = 75+heightoffset ;
		calx[ 8] = 53+widthoffset ; caly[ 8] = 75+heightoffset ;
		calx[ 9] = 89+widthoffset ; caly[ 9] = 75+heightoffset ;
		calx[10] = 13+widthoffset ; caly[10] = 90+heightoffset ;
		calx[11] = 53+widthoffset ; caly[11] =   heightoffset ;
		calx[12] = 53+widthoffset ; caly[12] = 30+heightoffset ;
		calx[13] = 13+widthoffset ; caly[13] = 15+heightoffset ;
		calx[14] = 89+widthoffset ; caly[14] = 15+heightoffset ;
		calx[15] = 53+widthoffset ; caly[15] = 15+heightoffset ;
		calx[16] = 89+widthoffset ; caly[16] = 90+heightoffset ;
		cals[0] = "0";  cals[1] = "1";  cals[2] = "2";
		cals[3] = "3";  cals[4] = "4";  cals[5] = "5";
		cals[6] = "6";  cals[7] = "7";  cals[8] = "8";
		cals[9] = "9";  cals[10]= ".";  cals[11]= "+";
		cals[12]= "-";  cals[13]= "*";  cals[14]= "/";
		cals[15]= "=";  cals[16]= "00";
		widthoffset += 7 ;
		addCommand( new Command( "clear",  Command.CANCEL,   CalMac.Fun_cls)) ;
		addCommand( new Command( "paste",  Command.CANCEL,   CalMac.Fun_paste)) ;
		addCommand( new Command( "copy",  Command.CANCEL,   CalMac.Fun_copy)) ;
		setCommandListener( this) ;
		return ;
	}

	public void  paint(Graphics g) {
		int i ;
		g.setColor(16777215);
		g.fillRect( 0, 0, width, height) ;
		g.setColor( 130815) ;
		g.fillRect( 0, 0, width, 24) ;
		g.setColor( 0) ;

		g.setColor( 12632256) ;
		for( i=16; i>=0; i--){
			g.fillRoundRect( calx[i]-15, caly[i],  28, 12,  5, 5) ;
		}
		if( updatenum >= 0 && updatenum <= 16){
			g.setColor( 16743551) ;
			g.fillRoundRect( calx[updatenum]-15, caly[updatenum],  28, 12,  5, 5) ;
		}
		g.setColor( 0) ;
		for( i=16; i>=0; i--){
			g.drawString( cals[i], calx[i], caly[i],  g.HCENTER|g.TOP) ;
		}
		g.drawString( DispOld,  width-widthoffset,   0,  g.TOP|g.RIGHT) ;
		g.drawString( DispProp,  width-widthoffset,  12,  g.TOP|g.RIGHT) ;
		g.drawChar( DispOp,    widthoffset+7, 12, g.TOP|g.LEFT) ;
		g.drawLine( 0, 24, width-1, 24) ;
		updatenum = -1 ;
		return ;
	}

	public void keyPressed( int keycode){
		if( operand==CalMac.Error){
			return ;
		}
		keycode = getMyGameAction(keycode);
		try {
		switch( keycode){
			case  KEY_NUM0 :
				updatenum = 0 ;
				SendNum( CalMac.Num_0) ;
				break ;

			case  KEY_NUM1 :
				updatenum = 1 ;
				SendNum( CalMac.Num_1) ;
				break ;

			case  KEY_NUM2 :
				updatenum = 2 ;
				SendNum( CalMac.Num_2) ;
				break ;

			case  KEY_NUM3 :
				updatenum = 3 ;
				SendNum( CalMac.Num_3) ;
				break ;

			case  KEY_NUM4 :
				updatenum = 4 ;
				SendNum( CalMac.Num_4) ;
				break ;

			case  KEY_NUM5 :
				updatenum = 5 ;
				SendNum( CalMac.Num_5) ;
				break ;

			case  KEY_NUM6 :
				updatenum = 6 ;
				SendNum( CalMac.Num_6) ;
				break ;

			case  KEY_NUM7 :
				updatenum = 7 ;
				SendNum( CalMac.Num_7) ;
				break ;

			case  KEY_NUM8 :
				updatenum = 8 ;
				SendNum( CalMac.Num_8) ;
				break ;

			case  KEY_NUM9 :
				updatenum = 9 ;
				SendNum( CalMac.Num_9) ;
				break ;

			case  KEY_POUND :
				updatenum = 16 ;
				SendNum( CalMac.Num_0) ;
				SendNum( CalMac.Num_0) ;
				break ;

			case  KEY_STAR :
				updatenum = 10 ;
				if( nextDspClear>0){
					DispProp = "0." ;
					nextDspClear = 0 ;
					keta = 1 ;
					isdot = true;
				} else if( !isdot) {
					DispProp += "." ;
					isdot = true ;
				}
				break ;

			case  UP :
				updatenum = 11 ;
				Calculate() ;
				operand = CalMac.Op_plus ;
				setDspOp() ;
				break ;

			case  DOWN :
				updatenum = 12 ;
				Calculate() ;
				operand = CalMac.Op_minus ;
				setDspOp() ;
				break ;

			case  LEFT :
				updatenum = 13 ;
				Calculate() ;
				operand = CalMac.Op_mul ;
				setDspOp() ;
				break ;

			case  RIGHT:
				updatenum = 14;
				Calculate() ;
				operand = CalMac.Op_div ;
				setDspOp() ;
				break ;

			case  FIRE :
				updatenum = 15 ;
				if( operand==CalMac.Op_equal){
					break ;
				}
				Calculate() ;
				operand = CalMac.Op_equal ;
				DispOld = "" ;
				setDspOp() ;
				break ;

			default :
				updatenum = -1 ;
				break ;
		}
		cls_state = false ;
		} catch ( ArithmeticException e){
			operand = CalMac.Error ;
			setDspOp() ;
		}
		repaint () ;
		return ;
	}

	public void commandAction( Command c, Displayable d){
		int i = c.getPriority() ;
		if( operand==CalMac.Error){
			if( i==CalMac.Fun_cls){
				cls_state = true ;
			} else {
				return ;
			}
		}
		switch( i){
			case  CalMac.Fun_cls :
				if( cls_state){
					DispOp = ' ' ;
					DispOld = "" ;
					operand = 0 ;
					origin.clear() ;
				}
				cls_state = true ;
				DispProp = "0" ;
				nextDspClear = 1 ;
				isdot = false ;
				keta = 0 ;
				repaint () ;
				return ;

			case  CalMac.Fun_paste :
				DispProp = Clip ;
				nextDspClear = 2 ;
				break ;
			case  CalMac.Fun_copy :
				Clip = DispProp ;
				break ;
		}
		cls_state = false ;
		repaint () ;
		return ;
	}




	private void  SendNum( int num){
		if( nextDspClear>0){
			if( num==0){
				DispProp = "0" ;
				return ;
			}
			keta = 1 ;
			setDspOp() ;
			DispProp = String.valueOf( num) ;
			nextDspClear = 0 ;
			isdot = false ;
			return ;
		} else if( keta > 8){
			return ;
		} else {
			keta++ ;
			DispProp += num ;
			return ;
		}
	}

	private void  setDspOp () {
		switch( operand){
			case  CalMac.Op_plus :
				DispOp = '+' ;
				return ;

			case  CalMac.Op_minus :
				DispOp = '-' ;
				return ;

			case  CalMac.Op_mul :
				DispOp = '*' ;
				return ;

			case  CalMac.Op_div :
				DispOp = '/' ;
				return ;

			case  CalMac.Op_equal :
				DispOp = '=' ;
				return ;

			case  CalMac.Error :
				DispOp = 'E' ;
				return ;

			default :
				DispOp = ' ' ;
				return ;
		}
	}

	private void  Calculate() throws ArithmeticException {
		if( nextDspClear==1){
			DispOld = DispProp ;
			return ;
		}
		tmp.set( DispProp) ;

		switch( operand){
			case  CalMac.Op_plus :
				origin.add( tmp) ;
				break ;

			case  CalMac.Op_minus :
				origin.sub( tmp) ;
				break ;

			case  CalMac.Op_mul :
				origin.mul( tmp) ;
				break ;

			case  CalMac.Op_div :
				origin.div( tmp);
				break ;

			default :
				origin.set( tmp) ;
				break ;
		}
//		DispOld = origin.toString () ;
		String str = origin.toString () ;
		int i = str.indexOf('.') ;
		if( i>=0){
			int ii = str.length() -1;
			while( str.charAt(ii)=='0'){
				ii-- ;
			}
			if( i==ii){
				DispOld = str.substring( 0, i) ;
			} else {
				DispOld = str.substring( 0, ii+1) ;
			}
		} else {
			DispOld = str ;
		}
		DispProp = DispOld ;
		nextDspClear = 1 ;
		return ;
	}

	private int getMyGameAction(int keycode){
		switch( keycode){
			case  KEY_NUM0 :
			case  KEY_NUM1 :
			case  KEY_NUM2 :
			case  KEY_NUM3 :
			case  KEY_NUM4 :
			case  KEY_NUM5 :
			case  KEY_NUM6 :
			case  KEY_NUM7 :
			case  KEY_NUM8 :
			case  KEY_NUM9 :
			case  KEY_POUND :
			case  KEY_STAR :
				return  keycode ;
			default:
				return  getGameAction(keycode) ;
		}
	}
}
